Index: test/graph_maps_test.h
===================================================================
--- test/graph_maps_test.h	(revision 209)
+++ test/graph_maps_test.h	(revision 209)
@@ -0,0 +1,144 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_TEST_MAP_TEST_H
+#define LEMON_TEST_MAP_TEST_H
+
+#include <vector>
+#include <lemon/maps.h>
+
+#include "test_tools.h"
+
+namespace lemon {
+
+  template <typename Graph>
+  void checkGraphNodeMap() {
+    Graph graph;
+    const int num = 16;
+
+    typedef typename Graph::Node Node;
+
+    std::vector<Node> nodes;
+    for (int i = 0; i < num; ++i) {
+      nodes.push_back(graph.addNode());
+    }
+    typedef typename Graph::template NodeMap<int> IntNodeMap;
+    IntNodeMap map(graph, 42);
+    for (int i = 0; i < int(nodes.size()); ++i) {
+      check(map[nodes[i]] == 42, "Wrong map constructor.");
+    }
+    for (int i = 0; i < num; ++i) {
+      nodes.push_back(graph.addNode());
+      map[nodes.back()] = 23;
+      check(map[nodes.back()] == 23, "Wrong operator[].");
+    }
+    map = constMap<Node>(12);
+    for (int i = 0; i < int(nodes.size()); ++i) {
+      check(map[nodes[i]] == 12, "Wrong map constructor.");
+    }
+    graph.clear();
+    nodes.clear();
+  }
+
+  template <typename Graph>
+  void checkGraphArcMap() {
+    Graph graph;
+    const int num = 16;
+
+    typedef typename Graph::Node Node;
+    typedef typename Graph::Arc Arc;
+
+    std::vector<Node> nodes;
+    for (int i = 0; i < num; ++i) {
+      nodes.push_back(graph.addNode());
+    }
+
+    std::vector<Arc> arcs;
+    for (int i = 0; i < num; ++i) {
+      for (int j = 0; j < i; ++j) {
+        arcs.push_back(graph.addArc(nodes[i], nodes[j]));
+      }
+    }
+
+    typedef typename Graph::template ArcMap<int> IntArcMap;
+    IntArcMap map(graph, 42);
+
+    for (int i = 0; i < int(arcs.size()); ++i) {
+      check(map[arcs[i]] == 42, "Wrong map constructor.");
+    }
+
+    for (int i = 0; i < num; ++i) {
+      for (int j = i + 1; j < num; ++j) {
+        arcs.push_back(graph.addArc(nodes[i], nodes[j]));
+        map[arcs.back()] = 23;
+        check(map[arcs.back()] == 23, "Wrong operator[].");
+      }
+    }
+    map = constMap<Arc>(12);
+    for (int i = 0; i < int(arcs.size()); ++i) {
+      check(map[arcs[i]] == 12, "Wrong map constructor.");
+    }
+    graph.clear();
+    arcs.clear();
+  }
+
+  template <typename Graph>
+  void checkGraphEdgeMap() {
+    Graph graph;
+    const int num = 16;
+
+    typedef typename Graph::Node Node;
+    typedef typename Graph::Edge Edge;
+
+    std::vector<Node> nodes;
+    for (int i = 0; i < num; ++i) {
+      nodes.push_back(graph.addNode());
+    }
+
+    std::vector<Edge> edges;
+    for (int i = 0; i < num; ++i) {
+      for (int j = 0; j < i; ++j) {
+        edges.push_back(graph.addEdge(nodes[i], nodes[j]));
+      }
+    }
+
+    typedef typename Graph::template EdgeMap<int> IntEdgeMap;
+    IntEdgeMap map(graph, 42);
+
+    for (int i = 0; i < int(edges.size()); ++i) {
+      check(map[edges[i]] == 42, "Wrong map constructor.");
+    }
+
+    for (int i = 0; i < num; ++i) {
+      for (int j = i + 1; j < num; ++j) {
+        edges.push_back(graph.addEdge(nodes[i], nodes[j]));
+        map[edges.back()] = 23;
+        check(map[edges.back()] == 23, "Wrong operator[].");
+      }
+    }
+    map = constMap<Edge>(12);
+    for (int i = 0; i < int(edges.size()); ++i) {
+      check(map[edges[i]] == 12, "Wrong map constructor.");
+    }
+    graph.clear();
+    edges.clear();
+  }
+
+}
+
+#endif
Index: test/graph_test.cc
===================================================================
--- test/graph_test.cc	(revision 228)
+++ test/graph_test.cc	(revision 209)
@@ -25,76 +25,10 @@
 #include "test_tools.h"
 #include "graph_test.h"
+#include "graph_maps_test.h"
 
 using namespace lemon;
 using namespace lemon::concepts;
 
-template <class Graph>
-void checkGraph() {
-  TEMPLATE_GRAPH_TYPEDEFS(Graph);
-
-  Graph G;
-  checkGraphNodeList(G, 0);
-  checkGraphEdgeList(G, 0);
-
-  Node
-    n1 = G.addNode(),
-    n2 = G.addNode(),
-    n3 = G.addNode();
-  checkGraphNodeList(G, 3);
-  checkGraphEdgeList(G, 0);
-
-  Edge e1 = G.addEdge(n1, n2);
-  check((G.u(e1) == n1 && G.v(e1) == n2) || (G.u(e1) == n2 && G.v(e1) == n1),
-        "Wrong edge");
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 2);
-  checkGraphEdgeList(G, 1);
-
-  checkGraphOutArcList(G, n1, 1);
-  checkGraphOutArcList(G, n2, 1);
-  checkGraphOutArcList(G, n3, 0);
-
-  checkGraphInArcList(G, n1, 1);
-  checkGraphInArcList(G, n2, 1);
-  checkGraphInArcList(G, n3, 0);
-
-  checkGraphIncEdgeList(G, n1, 1);
-  checkGraphIncEdgeList(G, n2, 1);
-  checkGraphIncEdgeList(G, n3, 0);
-
-  checkGraphConArcList(G, 2);
-  checkGraphConEdgeList(G, 1);
-
-  Edge e2 = G.addEdge(n2, n1), e3 = G.addEdge(n2, n3);
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 6);
-  checkGraphEdgeList(G, 3);
-
-  checkGraphOutArcList(G, n1, 2);
-  checkGraphOutArcList(G, n2, 3);
-  checkGraphOutArcList(G, n3, 1);
-
-  checkGraphInArcList(G, n1, 2);
-  checkGraphInArcList(G, n2, 3);
-  checkGraphInArcList(G, n3, 1);
-
-  checkGraphIncEdgeList(G, n1, 2);
-  checkGraphIncEdgeList(G, n2, 3);
-  checkGraphIncEdgeList(G, n3, 1);
-
-  checkGraphConArcList(G, 6);
-  checkGraphConEdgeList(G, 3);
-
-  checkArcDirections(G);
-
-  checkNodeIds(G);
-  checkArcIds(G);
-  checkEdgeIds(G);
-  checkGraphNodeMap(G);
-  checkGraphArcMap(G);
-  checkGraphEdgeMap(G);
-}
-
-void checkConcepts() {
+void check_concepts() {
   { // Checking graph components
     checkConcept<BaseGraphComponent, BaseGraphComponent >();
@@ -118,4 +52,5 @@
     checkConcept<ClearableGraphComponent<>, ListGraph>();
     checkConcept<ErasableGraphComponent<>, ListGraph>();
+    checkGraphIterators<ListGraph>();
   }
   { // Checking SmartGraph
@@ -124,4 +59,5 @@
     checkConcept<ExtendableGraphComponent<>, SmartGraph>();
     checkConcept<ClearableGraphComponent<>, SmartGraph>();
+    checkGraphIterators<SmartGraph>();
   }
 //  { // Checking FullGraph
@@ -136,5 +72,5 @@
 
 template <typename Graph>
-void checkGraphValidity() {
+void check_graph_validity() {
   TEMPLATE_GRAPH_TYPEDEFS(Graph);
   Graph g;
@@ -159,5 +95,5 @@
 
 template <typename Graph>
-void checkGraphValidityErase() {
+void check_graph_validity_erase() {
   TEMPLATE_GRAPH_TYPEDEFS(Graph);
   Graph g;
@@ -233,12 +169,18 @@
 // }
 
-void checkGraphs() {
+void check_graphs() {
   { // Checking ListGraph
     checkGraph<ListGraph>();
-    checkGraphValidityErase<ListGraph>();
+    checkGraphNodeMap<ListGraph>();
+    checkGraphEdgeMap<ListGraph>();
+
+    check_graph_validity_erase<ListGraph>();
   }
   { // Checking SmartGraph
     checkGraph<SmartGraph>();
-    checkGraphValidity<SmartGraph>();
+    checkGraphNodeMap<SmartGraph>();
+    checkGraphEdgeMap<SmartGraph>();
+
+    check_graph_validity<SmartGraph>();
   }
 //   { // Checking FullGraph
@@ -256,6 +198,6 @@
 
 int main() {
-  checkConcepts();
-  checkGraphs();
+  check_concepts();
+  check_graphs();
   return 0;
 }
Index: test/graph_test.h
===================================================================
--- test/graph_test.h	(revision 263)
+++ test/graph_test.h	(revision 220)
@@ -20,9 +20,5 @@
 #define LEMON_TEST_GRAPH_TEST_H
 
-#include <set>
-
 #include <lemon/core.h>
-#include <lemon/maps.h>
-
 #include "test_tools.h"
 
@@ -47,8 +43,4 @@
     for(int i=0;i<cnt;i++) {
       check(e!=INVALID,"Wrong Arc list linking.");
-      check(G.oppositeNode(G.source(e), e) == G.target(e),
-            "Wrong opposite node");
-      check(G.oppositeNode(G.target(e), e) == G.source(e),
-            "Wrong opposite node");
       ++e;
     }
@@ -64,6 +56,4 @@
       check(e!=INVALID,"Wrong OutArc list linking.");
       check(n==G.source(e),"Wrong OutArc list linking.");
-      check(n==G.baseNode(e),"Wrong OutArc list linking.");
-      check(G.target(e)==G.runningNode(e),"Wrong OutArc list linking.");
       ++e;
     }
@@ -79,6 +69,4 @@
       check(e!=INVALID,"Wrong InArc list linking.");
       check(n==G.target(e),"Wrong InArc list linking.");
-      check(n==G.baseNode(e),"Wrong OutArc list linking.");
-      check(G.source(e)==G.runningNode(e),"Wrong OutArc list linking.");
       ++e;
     }
@@ -93,6 +81,4 @@
     for(int i=0;i<cnt;i++) {
       check(e!=INVALID,"Wrong Edge list linking.");
-      check(G.oppositeNode(G.u(e), e) == G.v(e), "Wrong opposite node");
-      check(G.oppositeNode(G.v(e), e) == G.u(e), "Wrong opposite node");
       ++e;
     }
@@ -108,7 +94,4 @@
       check(e!=INVALID,"Wrong IncEdge list linking.");
       check(n==G.u(e) || n==G.v(e),"Wrong IncEdge list linking.");
-      check(n==G.baseNode(e),"Wrong OutArc list linking.");
-      check(G.u(e)==G.runningNode(e) || G.v(e)==G.runningNode(e),
-            "Wrong OutArc list linking.");
       ++e;
     }
@@ -117,166 +100,161 @@
   }
 
+  template <class Digraph>
+  void checkDigraphIterators() {
+    typedef typename Digraph::Node Node;
+    typedef typename Digraph::NodeIt NodeIt;
+    typedef typename Digraph::Arc Arc;
+    typedef typename Digraph::ArcIt ArcIt;
+    typedef typename Digraph::InArcIt InArcIt;
+    typedef typename Digraph::OutArcIt OutArcIt;
+  }
+
   template <class Graph>
-  void checkGraphConArcList(const Graph &G, int cnt) {
-    int i = 0;
-    for (typename Graph::NodeIt u(G); u != INVALID; ++u) {
-      for (typename Graph::NodeIt v(G); v != INVALID; ++v) {
-        for (ConArcIt<Graph> a(G, u, v); a != INVALID; ++a) {
-          check(G.source(a) == u, "Wrong iterator.");
-          check(G.target(a) == v, "Wrong iterator.");
-          ++i;
-        }
-      }
-    }
-    check(cnt == i, "Wrong iterator.");
-  }
-
-  template <class Graph>
-  void checkGraphConEdgeList(const Graph &G, int cnt) {
-    int i = 0;
-    for (typename Graph::NodeIt u(G); u != INVALID; ++u) {
-      for (typename Graph::NodeIt v(G); v != INVALID; ++v) {
-        for (ConEdgeIt<Graph> e(G, u, v); e != INVALID; ++e) {
-          check((G.u(e) == u && G.v(e) == v) ||
-                (G.u(e) == v && G.v(e) == u), "Wrong iterator.");
-          i += u == v ? 2 : 1;
-        }
-      }
-    }
-    check(2 * cnt == i, "Wrong iterator.");
-  }
-
-  template <typename Graph>
-  void checkArcDirections(const Graph& G) {
-    for (typename Graph::ArcIt a(G); a != INVALID; ++a) {
-      check(G.source(a) == G.target(G.oppositeArc(a)), "Wrong direction");
-      check(G.target(a) == G.source(G.oppositeArc(a)), "Wrong direction");
-      check(G.direct(a, G.direction(a)) == a, "Wrong direction");
-    }
-  }
-
-  template <typename Graph>
-  void checkNodeIds(const Graph& G) {
-    std::set<int> values;
-    for (typename Graph::NodeIt n(G); n != INVALID; ++n) {
-      check(G.nodeFromId(G.id(n)) == n, "Wrong id");
-      check(values.find(G.id(n)) == values.end(), "Wrong id");
-      check(G.id(n) <= G.maxNodeId(), "Wrong maximum id");
-      values.insert(G.id(n));
-    }
-  }
-
-  template <typename Graph>
-  void checkArcIds(const Graph& G) {
-    std::set<int> values;
-    for (typename Graph::ArcIt a(G); a != INVALID; ++a) {
-      check(G.arcFromId(G.id(a)) == a, "Wrong id");
-      check(values.find(G.id(a)) == values.end(), "Wrong id");
-      check(G.id(a) <= G.maxArcId(), "Wrong maximum id");
-      values.insert(G.id(a));
-    }
-  }
-
-  template <typename Graph>
-  void checkEdgeIds(const Graph& G) {
-    std::set<int> values;
-    for (typename Graph::EdgeIt e(G); e != INVALID; ++e) {
-      check(G.edgeFromId(G.id(e)) == e, "Wrong id");
-      check(values.find(G.id(e)) == values.end(), "Wrong id");
-      check(G.id(e) <= G.maxEdgeId(), "Wrong maximum id");
-      values.insert(G.id(e));
-    }
-  }
-
-  template <typename Graph>
-  void checkGraphNodeMap(const Graph& G) {
-    typedef typename Graph::Node Node;
-    typedef typename Graph::NodeIt NodeIt;
-
-    typedef typename Graph::template NodeMap<int> IntNodeMap;
-    IntNodeMap map(G, 42);
-    for (NodeIt it(G); it != INVALID; ++it) {
-      check(map[it] == 42, "Wrong map constructor.");
-    }
-    int s = 0;
-    for (NodeIt it(G); it != INVALID; ++it) {
-      map[it] = 0;
-      check(map[it] == 0, "Wrong operator[].");
-      map.set(it, s);
-      check(map[it] == s, "Wrong set.");
-      ++s;
-    }
-    s = s * (s - 1) / 2;
-    for (NodeIt it(G); it != INVALID; ++it) {
-      s -= map[it];
-    }
-    check(s == 0, "Wrong sum.");
-
-    // map = constMap<Node>(12);
-    // for (NodeIt it(G); it != INVALID; ++it) {
-    //   check(map[it] == 12, "Wrong operator[].");
-    // }
-  }
-
-  template <typename Graph>
-  void checkGraphArcMap(const Graph& G) {
-    typedef typename Graph::Arc Arc;
-    typedef typename Graph::ArcIt ArcIt;
-
-    typedef typename Graph::template ArcMap<int> IntArcMap;
-    IntArcMap map(G, 42);
-    for (ArcIt it(G); it != INVALID; ++it) {
-      check(map[it] == 42, "Wrong map constructor.");
-    }
-    int s = 0;
-    for (ArcIt it(G); it != INVALID; ++it) {
-      map[it] = 0;
-      check(map[it] == 0, "Wrong operator[].");
-      map.set(it, s);
-      check(map[it] == s, "Wrong set.");
-      ++s;
-    }
-    s = s * (s - 1) / 2;
-    for (ArcIt it(G); it != INVALID; ++it) {
-      s -= map[it];
-    }
-    check(s == 0, "Wrong sum.");
-
-    // map = constMap<Arc>(12);
-    // for (ArcIt it(G); it != INVALID; ++it) {
-    //   check(map[it] == 12, "Wrong operator[].");
-    // }
-  }
-
-  template <typename Graph>
-  void checkGraphEdgeMap(const Graph& G) {
+  void checkGraphIterators() {
+    checkDigraphIterators<Graph>();
     typedef typename Graph::Edge Edge;
     typedef typename Graph::EdgeIt EdgeIt;
-
-    typedef typename Graph::template EdgeMap<int> IntEdgeMap;
-    IntEdgeMap map(G, 42);
-    for (EdgeIt it(G); it != INVALID; ++it) {
-      check(map[it] == 42, "Wrong map constructor.");
-    }
-    int s = 0;
-    for (EdgeIt it(G); it != INVALID; ++it) {
-      map[it] = 0;
-      check(map[it] == 0, "Wrong operator[].");
-      map.set(it, s);
-      check(map[it] == s, "Wrong set.");
-      ++s;
-    }
-    s = s * (s - 1) / 2;
-    for (EdgeIt it(G); it != INVALID; ++it) {
-      s -= map[it];
-    }
-    check(s == 0, "Wrong sum.");
-
-    // map = constMap<Edge>(12);
-    // for (EdgeIt it(G); it != INVALID; ++it) {
-    //   check(map[it] == 12, "Wrong operator[].");
-    // }
-  }
-
+    typedef typename Graph::IncEdgeIt IncEdgeIt;
+  }
+
+  // Structure returned by addPetersen()
+  template<class Digraph>
+  struct PetStruct
+  {
+    // Vector containing the outer nodes
+    std::vector<typename Digraph::Node> outer;
+    // Vector containing the inner nodes
+    std::vector<typename Digraph::Node> inner;
+    // Vector containing the arcs of the inner circle
+    std::vector<typename Digraph::Arc> incir;
+    // Vector containing the arcs of the outer circle
+    std::vector<typename Digraph::Arc> outcir;
+    // Vector containing the chord arcs
+    std::vector<typename Digraph::Arc> chords;
+  };
+
+  // Adds the reverse pair of all arcs to a digraph
+  template<class Digraph>
+  void bidirDigraph(Digraph &G)
+  {
+    typedef typename Digraph::Arc Arc;
+    typedef typename Digraph::ArcIt ArcIt;
+
+    std::vector<Arc> ee;
+
+    for(ArcIt e(G);e!=INVALID;++e) ee.push_back(e);
+
+    for(int i=0;i<int(ee.size());++i)
+      G.addArc(G.target(ee[i]),G.source(ee[i]));
+  }
+
+  // Adds a Petersen digraph to G.
+  // Returns the nodes and arcs of the generated digraph.
+  template<typename Digraph>
+  PetStruct<Digraph> addPetersen(Digraph &G,int num = 5)
+  {
+    PetStruct<Digraph> n;
+
+    for(int i=0;i<num;i++) {
+      n.outer.push_back(G.addNode());
+      n.inner.push_back(G.addNode());
+    }
+
+    for(int i=0;i<num;i++) {
+      n.chords.push_back(G.addArc(n.outer[i],n.inner[i]));
+      n.outcir.push_back(G.addArc(n.outer[i],n.outer[(i+1) % num]));
+      n.incir.push_back(G.addArc(n.inner[i],n.inner[(i+2) % num]));
+    }
+
+    return n;
+  }
+
+  // Checks the bidirectioned Petersen digraph
+  template<class Digraph>
+  void checkBidirPetersen(const Digraph &G, int num = 5)
+  {
+    typedef typename Digraph::NodeIt NodeIt;
+
+    checkGraphNodeList(G, 2 * num);
+    checkGraphArcList(G, 6 * num);
+
+    for(NodeIt n(G);n!=INVALID;++n) {
+      checkGraphInArcList(G, n, 3);
+      checkGraphOutArcList(G, n, 3);
+    }
+  }
+
+  // Structure returned by addUPetersen()
+  template<class Graph>
+  struct UPetStruct
+  {
+    // Vector containing the outer nodes
+    std::vector<typename Graph::Node> outer;
+    // Vector containing the inner nodes
+    std::vector<typename Graph::Node> inner;
+    // Vector containing the edges of the inner circle
+    std::vector<typename Graph::Edge> incir;
+    // Vector containing the edges of the outer circle
+    std::vector<typename Graph::Edge> outcir;
+    // Vector containing the chord edges
+    std::vector<typename Graph::Edge> chords;
+  };
+
+  // Adds a Petersen graph to \c G.
+  // Returns the nodes and edges of the generated graph.
+  template<typename Graph>
+  UPetStruct<Graph> addUPetersen(Graph &G,int num=5)
+  {
+    UPetStruct<Graph> n;
+
+    for(int i=0;i<num;i++) {
+      n.outer.push_back(G.addNode());
+      n.inner.push_back(G.addNode());
+    }
+
+    for(int i=0;i<num;i++) {
+      n.chords.push_back(G.addEdge(n.outer[i],n.inner[i]));
+      n.outcir.push_back(G.addEdge(n.outer[i],n.outer[(i+1)%num]));
+      n.incir.push_back(G.addEdge(n.inner[i],n.inner[(i+2)%num]));
+    }
+
+    return n;
+  }
+
+  // Checks the undirected Petersen graph
+  template<class Graph>
+  void checkUndirPetersen(const Graph &G, int num = 5)
+  {
+    typedef typename Graph::NodeIt NodeIt;
+
+    checkGraphNodeList(G, 2 * num);
+    checkGraphEdgeList(G, 3 * num);
+    checkGraphArcList(G, 6 * num);
+
+    for(NodeIt n(G);n!=INVALID;++n) {
+      checkGraphIncEdgeList(G, n, 3);
+    }
+  }
+
+  template <class Digraph>
+  void checkDigraph() {
+    const int num = 5;
+    Digraph G;
+    checkGraphNodeList(G, 0);
+    checkGraphArcList(G, 0);
+    addPetersen(G, num);
+    bidirDigraph(G);
+    checkBidirPetersen(G, num);
+  }
+
+  template <class Graph>
+  void checkGraph() {
+    const int num = 5;
+    Graph G;
+    checkGraphNodeList(G, 0);
+    checkGraphEdgeList(G, 0);
+    addUPetersen(G, num);
+    checkUndirPetersen(G, num);
+  }
 
 } //namespace lemon
Index: test/graph_utils_test.cc
===================================================================
--- test/graph_utils_test.cc	(revision 301)
+++ test/graph_utils_test.cc	(revision 220)
@@ -36,10 +36,9 @@
   {
     Digraph digraph;
-    typename Digraph::template NodeMap<int> nodes(digraph);
-    std::vector<Node> invNodes;
     for (int i = 0; i < 10; ++i) {
-      invNodes.push_back(digraph.addNode());
-      nodes[invNodes.back()]=invNodes.size()-1;
-    }
+      digraph.addNode();
+    }
+    DescriptorMap<Digraph, Node> nodes(digraph);
+    typename DescriptorMap<Digraph, Node>::InverseMap invNodes(nodes);
     for (int i = 0; i < 100; ++i) {
       int src = rnd[invNodes.size()];
@@ -48,4 +47,5 @@
     }
     typename Digraph::template ArcMap<bool> found(digraph, false);
+    DescriptorMap<Digraph, Arc> arcs(digraph);
     for (NodeIt src(digraph); src != INVALID; ++src) {
       for (NodeIt trg(digraph); trg != INVALID; ++trg) {
@@ -111,10 +111,9 @@
   TEMPLATE_GRAPH_TYPEDEFS(Graph);
   Graph graph;
-  typename Graph::template NodeMap<int> nodes(graph);
-  std::vector<Node> invNodes;
   for (int i = 0; i < 10; ++i) {
-    invNodes.push_back(graph.addNode());
-    nodes[invNodes.back()]=invNodes.size()-1;
-  }
+    graph.addNode();
+  }
+  DescriptorMap<Graph, Node> nodes(graph);
+  typename DescriptorMap<Graph, Node>::InverseMap invNodes(nodes);
   for (int i = 0; i < 100; ++i) {
     int src = rnd[invNodes.size()];
@@ -123,4 +122,5 @@
   }
   typename Graph::template EdgeMap<int> found(graph, 0);
+  DescriptorMap<Graph, Edge> edges(graph);
   for (NodeIt src(graph); src != INVALID; ++src) {
     for (NodeIt trg(graph); trg != INVALID; ++trg) {
Index: test/heap_test.cc
===================================================================
--- test/heap_test.cc	(revision 293)
+++ test/heap_test.cc	(revision 212)
@@ -132,5 +132,5 @@
                       Node source) {
 
-  typename Dijkstra<Digraph, IntArcMap>::template SetStandardHeap<Heap>::
+  typename Dijkstra<Digraph, IntArcMap>::template DefStandardHeap<Heap>::
     Create dijkstra(digraph, length);
 
@@ -168,5 +168,5 @@
 
   std::istringstream input(test_lgf);
-  digraphReader(digraph, input).
+  digraphReader(input, digraph).
     arcMap("capacity", length).
     node("source", source).
Index: tools/Makefile.am
===================================================================
--- tools/Makefile.am	(revision 314)
+++ tools/Makefile.am	(revision 146)
@@ -2,5 +2,4 @@
 
 bin_PROGRAMS +=
-dist_bin_SCRIPTS += tools/lemon-0.x-to-1.x.sh
 
 endif WANT_TOOLS
